
'##################################################################################################
'Framework & Imports.
Framework BRL.Graphics
Import BRL.GLGraphics
Import BRL.LinkedList
Import BRL.Blitz
Import BRL.EndianStream
Import BRL.Retro
Import BRL.Win32MaxGUI
Import BRL.EventQueue
Import BRL.Random
Import BRL.AppTiming

'##################################################################################################
'Includes.
Include "Source\GlobalVariables.bmx"
Include "Source\Includes.bmx"

'##################################################################################################
TMainWindow.Create()
TApp.InitGL()

Global MyMesh:TMesh = TBMDLoader.Load( ModelDir )
MyMesh.Position( 0, -25, 150 )

'##################################################################################################
'Main Loop
Repeat
	UpdateAppTime()
	TApp.Cls()
	TMainWindow.Update()
	
	If KeyHit( KEY_ESCAPE ) Then TApp.Close()
	
	If Not KeyDown( KEY_RSHIFT )
		If KeyDown( KEY_UP ) Then
			MyMesh.Move( 0, 0, -2*AppSpeed() )
		ElseIf KeyDown( KEY_DOWN ) Then
			MyMesh.Move( 0, 0, 2*AppSpeed() )
		EndIf
		
		If KeyDown( KEY_LEFT ) Then
			MyMesh.Move( 2*AppSpeed(), 0, 0 )
		ElseIf KeyDown( KEY_RIGHT ) Then
			MyMesh.Move( -2*AppSpeed(), 0, 0 )
		EndIf
	Else
		If KeyDown( KEY_UP ) Then
			MyMesh.Move( 0, 0, -6*AppSpeed() )
		ElseIf KeyDown( KEY_DOWN ) Then
			MyMesh.Move( 0, 0, 6*AppSpeed() )
		EndIf
		
		If KeyDown( KEY_LEFT ) Then
			MyMesh.Move( 6*AppSpeed(), 0, 0 )
		ElseIf KeyDown( KEY_RIGHT ) Then
			MyMesh.Move( -6*AppSpeed(), 0, 0 )
		EndIf
	EndIf
	
	If MouseDown( 1 ) Then
		MyMesh.Turn( 0, MouseXSpeed(), MouseYSpeed() )
	EndIf
	
	MyMesh.Draw()
	
	glDisable(GL_LIGHT0)
	glDisable(GL_LIGHTING)
	glDisable(GL_COLOR_MATERIAL)
	GLDrawText( "FPS: "+UPS(), 0, 0 )
	glEnable(GL_LIGHT0)
	glEnable(GL_LIGHTING)
	glEnable(GL_COLOR_MATERIAL)
	
	TKey.Update()
	Flip()
	Delay 2
Forever
End
'##################################################################################################