
Type TBMDLoader
	
	Global Mesh:TMesh
	Global Surf:TSurface
	
	Function Load:TMesh( Dir:String )
		Self.Mesh:TMesh = TMesh.Create()
		Self.Surf:TSurface = TSurface.Create( Mesh, GL_TRIANGLE_STRIP )
		
		If FileType( Dir ) = FILETYPE_FILE
			Local File:TStream = BigEndianStream( ReadFile( Dir ) )
				ReadBMD( File )
			CloseFile( File )
		EndIf
		
		Surf.Free()
		Surf = Null
		
		Return Mesh
	End Function
	
	Function ReadBMD( File:TStream )
		
		'Skip File Header
		Print "-File Header Start-"
		Print "    " + ReadByteString:String( File , 4 ) 
		Print "    " + ReadByteString:String( File , 4 ) 
		Print "    " + "Size: " + ReadInt( File ) 
		Print "    " + "SectionCount: "+ReadInt( File )
		Print "-File Header End-"
		Print ""
		
		SeekStream( File, 32 )
		
		Local Tag:String
		Local Size:Int
		
		Repeat
			
			Local OldPos:Int = StreamPos( File ) 
			Tag = ReadByteString( File , 4 ) 
			Size = ReadInt( File ) 
			Print "[TAG] " + Tag
			
			Select Tag
				Case "INF1"
					DumpInf1( File, Size )
					
				Case "VTX1"
					DumpVtx1( File, Size )
					
				Case "EVP1"
					
				Case "DRW1"
					
				Case "JNT1"
					
				Case "SHP1"
					DumpShp1( File, Size )
					
				Case "MAT3"
					
				Case "TEX1"
					
				Default
					Print "Unrecognized Tag '" + Tag + "'"
					
			End Select
			
			SeekStream( File, OldPos + Size )
			
		Until Eof( File )
		
	End Function
		
	Function ReadByteString:String( File:TStream , ByteCount:Int ) 
		Local Str:String
		For Local X:Int = 0 To ByteCount - 1
			Str = Str + Chr(ReadByte( File ))
		Next
		Return Str
	End Function
	
End Type