
Type TSurface
	
	Field DrawFunc:Int
	Field DrawList:TList
	
	Function Create:TSurface( Mesh:TMesh, Draw )
		Local A:TSurface = New TSurface
			A.DrawList = CreateList()
			A.DrawFunc = Draw
			Mesh.SurfaceList.Addlast( A )
			Return( A )
	End Function
	
	Method Draw()
		glBegin( Self.DrawFunc )
			For Local A:TVertex = EachIn Self.DrawList
				
				If TShp1.UseNormals = 1
					Local N:TVector = TVtx1.Normals[ A.NormalIndex ]
						glNormal3f( N.X, N.Y, N.Z )
				EndIf
					
				Local P:TVector = TVtx1.Vertices[ A.PositionIndex ]
					glVertex3f( P.X, P.Y, P.Z )
			Next
		glEnd()
	End Method
	
	Function Link( Surf:TSurface, Vert:TVector )
		Surf.DrawList.Addlast( Vert )
	End Function
	
	Method Free()
		For Local A:TVertex = EachIn Self.DrawList
			Self.DrawList.Remove( A )
		Next
	End Method
	
End Type
