
'##################################################################################################
'Framework & Imports.
Framework BRL.Graphics
Import BRL.GLGraphics
Import BRL.LinkedList
Import BRL.Blitz
Import BRL.EndianStream
Import BRL.Retro
Import MaxGUI.Drivers
Import BRL.EventQueue
Import BRL.Random
Import LeadWerks.AppTiming
Import BRL.Pixmap
Import BRL.PNGLoader

'##################################################################################################
'Includes.
Include "Source\GlobalVariables.bmx"
Include "Source\Includes.bmx"

'##################################################################################################
TMainWindow.Create()
TApp.InitGL()

Global TempTexture:TTexture = TTexture.Load( "mariocap.png" )

Global MyMesh:TMesh = TBMDLoader.Load( ModelDir )
MyMesh.Position( 0, -25, 150 )

'##################################################################################################
'Main Loop
Repeat
	UpdateAppTime()
	TApp.Cls()
	TMainWindow.Update()
	
	If KeyHit( KEY_ESCAPE ) Then TApp.Close()
	
	If Not KeyDown( KEY_RSHIFT )
		If KeyDown( KEY_UP ) Then
			MyMesh.Move( 0, 0, -4*AppSpeed() )
		ElseIf KeyDown( KEY_DOWN ) Then
			MyMesh.Move( 0, 0, 4*AppSpeed() )
		EndIf
		
		If KeyDown( KEY_LEFT ) Then
			MyMesh.Move( 4*AppSpeed(), 0, 0 )
		ElseIf KeyDown( KEY_RIGHT ) Then
			MyMesh.Move( -4*AppSpeed(), 0, 0 )
		EndIf
	Else
		If KeyDown( KEY_UP ) Then
			MyMesh.Move( 0, 0, -10*AppSpeed() )
		ElseIf KeyDown( KEY_DOWN ) Then
			MyMesh.Move( 0, 0, 10*AppSpeed() )
		EndIf
		
		If KeyDown( KEY_LEFT ) Then
			MyMesh.Move( 10*AppSpeed(), 0, 0 )
		ElseIf KeyDown( KEY_RIGHT ) Then
			MyMesh.Move( -10*AppSpeed(), 0, 0 )
		EndIf
	EndIf
	
	If MouseDown( 1 ) Then
		MyMesh.Turn( 0, MouseXSpeed(), MouseYSpeed() )
	EndIf
	
	MyMesh.Draw()
	
	TApp.DrawText( "FPS: "+UPS(), 0, 0 )
	
	TKey.Update()
	Flip()
	Delay 2
Forever
End
'##################################################################################################