
Type TMainWindow
	
	Global Interface:TGadget[10]
	
	Function Create()
		
		Local WW:Int = Int(TApp.G_Width)
		Local WH:Int = Int(TApp.G_Height)
		Local WX:Int = ClientWidth( Desktop() ) / 2 - WW / 2
		Local WY:Int = ClientHeight( Desktop() ) / 2 - WH / 2
		Local WF:Int = WINDOW_TITLEBAR | WINDOW_CLIENTCOORDS | WINDOW_ACCEPTFILES | WINDOW_MENU
		Local WT:String = "BMD Tool R01"
		
		Interface[0] = CreateWindow( WT, WX, WY, WW, WH, Null, WF )
		Interface[1] = CreateCanvas( 0 , 0 , WW , WH , Interface[0] ) 
		
		ActivateGadget( Interface[1] )
		
		TMainWindowMenuFile.Create()
		TMainWindowMenuHelp.Create()
		
	End Function
	
	Function Update()
		If PeekEvent() <> Null
			WaitEvent() 
			Select EventID() 
				
				Case EVENT_WINDOWCLOSE
					TApp.Close()
				
				Case EVENT_KEYDOWN
					TKey.UpdateKey( EventData(), 1 )
					
				Case EVENT_KEYUP
					TKey.UpdateKey( EventData(), 0 )
				
				Case EVENT_MOUSEDOWN
					TKey.UpdateMouseButton( EventData(), 1 )
					
				Case EVENT_MOUSEUP
					TKey.UpdateMouseButton( EventData(), 0 )
				
				Case EVENT_MOUSEMOVE
					TKey.OMPos[0] = TKey.MPos[0]
					TKey.MPos[0] = EventX()
					TKey.OMPos[1] = TKey.MPos[1]
					TKey.MPos[1] = EventY()
				
				Case EVENT_WINDOWACCEPT
					If MyMesh <> Null
						MyMesh.Free()
						MyMesh = Null
					EndIf
					MyMesh = TBMDLoader.Load( EventText() )
					MyMesh.Position( 0, -25, 150 )
					
				Case EVENT_WINDOWACTIVATE
					ActivateGadget( Interface[1] )
				
				Case EVENT_MOUSEWHEEL
					If EventData() > 0
						MyMesh.Move( 0, 0, (-EventData()*100) )
					ElseIf EventData() < 0
						MyMesh.Move( 0, 0, (-EventData()*100) )
					EndIf
				
			End Select
			TMainWindowMenuFile.Update()
			TMainWindowMenuHelp.Update()
		EndIf
	End Function
	
	
End Type
