
Type TMesh
	
	Global List:TList = CreateList()
	
	Field SurfaceList:TList
	Field X:Float , Y:Float , Z:Float
	Field RX:Float, RZ:Float, RY:Float
	
	Function Create:TMesh()
		Local A:TMesh = New TMesh
			A.SurfaceList = CreateList() 
			A.List.Addlast( A ) 
			Return( A )
	End Function
	
	Method Draw() 
		glLoadIdentity()
		
		glTranslatef( Self.X, Self.Y, -Self.Z )
		
		glRotatef( Self.RX, 1.0, 0.0, 0.0 )
		glRotatef( Self.RY, 0.0, 1.0, 0.0 )
		glRotatef( Self.RZ, 0.0, 0.0, 1.0 )
		
		For Local A:TSurface = EachIn Self.SurfaceList
			A.DrawSelf()
		Next
	End Method
	
	Method Position( X:Float , Y:Float , Z:Float )
		Self.X = X
		Self.Y = Y
		Self.Z = Z
	End Method
	
	Method Move( X:Float, Y:Float, Z:Float )
		Self.X:+X
		Self.Y:+Y
		Self.Z:+Z
	End Method
	
	Method Rotate( Pitch:Float, Yaw:Float, Roll:Float )
		Self.RX = Pitch
		Self.RY = Yaw
		Self.RZ = Roll
	End Method
	
	Method Turn( Pitch:Float, Yaw:Float, Roll:Float )
		Self.RX:+Pitch
		Self.RY:+Yaw
		Self.RZ:+Roll
	End Method
	
	Method Free()
		Self.List.Remove( Self )
		For Local A:TSurface = EachIn Self.SurfaceList
			A.Free()
		Next
	End Method
	
End Type
