
Type TSurface
	
	Field DrawFunc:Int
	Field DrawList:TList
	Field HasNormals:Byte
	Field HasColors:Byte
	Field HasTexCoords:Byte
	
	Field Texture:TTexture
	
	Function Create:TSurface( Mesh:TMesh, Draw )
		Local A:TSurface = New TSurface
			A.DrawList = CreateList()
			A.DrawFunc = Draw
			'A.Texture = TempTexture
			Mesh.SurfaceList.Addlast( A )
			Return( A )
	End Function
	
	Method DrawSelf()
	
		Local C:TColor
		Local A:TVertex
		Local N:TVector
		Local P:TVector
		Local T:TTexCoord
		
		If Self.Texture <> Null
			Self.Texture.Bind()
		EndIf
		
		If Self.HasNormals = 1
			TApp.EnableLightning()
		EndIf
		glBegin( Self.DrawFunc )
			For A = EachIn Self.DrawList
				
				If Self.HasTexCoords = 1
					T = TVtx1.TexCoords[ 0, A.TexCoordIndex[0] ]
					glTexCoord2f( T.U, T.V )
				EndIf
				
				If Self.HasNormals = 1
					N = TVtx1.Normals[ A.NormalIndex ]
						glNormal3f( N.X, N.Y, N.Z )
				EndIf
				
				If Self.HasColors = 1
					C = TVtx1.Colors[0, A.ColorIndex[0] ]
						glColor4ub( C.R, C.G, C.B, C.A )
				EndIf
					
				P = TVtx1.Vertices[ A.PositionIndex ]
					glVertex3f( P.X, P.Y, P.Z )
				
				If Self.HasColors = 1
					glColor4ub( 255, 255, 255, 255 )
				EndIf
				
			Next
		glEnd()
		If Self.HasNormals = 1
			TApp.DisableLightning()
		EndIf
	End Method
	
	Rem
	Method DrawSelf()
		If Self.HasNormals = 1
			If Self.HasColors = 1
				DrawNC()
			Else
				DrawN()
			EndIf
		Else
			If Self.HasColors = 1
				DrawC()
			Else
				Draw()
			EndIf
		EndIf
	End Method
	
	Method DrawNC()
		Local C:TColor
		Local A:TVertex
		Local N:TVector
		Local P:TVector
		
		TApp.EnableLightning()
		glBegin( Self.DrawFunc )
			For A = EachIn Self.DrawList
				
				N = TVtx1.Normals[ A.NormalIndex ]
					glNormal3f( N.X, N.Y, N.Z )
					
				C = TVtx1.Colors[0, A.ColorIndex[0] ]
					glColor4ub( C.R, C.G, C.B, C.A )
					
				P = TVtx1.Vertices[ A.PositionIndex ]
					glVertex3f( P.X, P.Y, P.Z )
				
				glColor4ub( 255, 255, 255, 255 )
				
			Next
		glEnd()
		TApp.DisableLightning()
	End Method
	
	Method DrawC()
		Local C:TColor
		Local A:TVertex
		Local N:TVector
		Local P:TVector
		
		glBegin( Self.DrawFunc )
			For A = EachIn Self.DrawList
					
				C = TVtx1.Colors[0, A.ColorIndex[0] ]
					glColor4ub( C.R, C.G, C.B, C.A )
					
				P = TVtx1.Vertices[ A.PositionIndex ]
					glVertex3f( P.X, P.Y, P.Z )
				
				glColor4ub( 255, 255, 255, 255 )
				
			Next
		glEnd()
	End Method
	
	Method DrawN()
		Local C:TColor
		Local A:TVertex
		Local N:TVector
		Local P:TVector
		
		TApp.EnableLightning()
		glBegin( Self.DrawFunc )
			For A = EachIn Self.DrawList
				
				N = TVtx1.Normals[ A.NormalIndex ]
					glNormal3f( N.X, N.Y, N.Z )
					
				P = TVtx1.Vertices[ A.PositionIndex ]
					glVertex3f( P.X, P.Y, P.Z )
				
			Next
		glEnd()
		TApp.DisableLightning()
	End Method
	
	Method Draw()
		Local C:TColor
		Local A:TVertex
		Local N:TVector
		Local P:TVector
		
		glBegin( Self.DrawFunc )
			For A = EachIn Self.DrawList
					
				P = TVtx1.Vertices[ A.PositionIndex ]
					glVertex3f( P.X, P.Y, P.Z )
				
			Next
		glEnd()
	End Method
	End Rem
	
	Function Link( Surf:TSurface, Vert:TVector )
		Surf.DrawList.Addlast( Vert )
	End Function
	
	Method Free()
		For Local A:TVertex = EachIn Self.DrawList
			Self.DrawList.Remove( A )
		Next
	End Method
	
End Type
