
Type TApp
	
	Global G_Width:Float = 1024.0
	Global G_Height:Float = 768.0
	
	Function InitGL() 
		
		AppTitle = "BMD Tool R01"
		
		SetGraphicsDriver( GLGraphicsDriver() )
		
		SetGraphics( CanvasGraphics( TMainWindow.Interface[1] ) )
		
		glTexParameterf(GL_TEXTURE_2D, GL_MAG_FILTER, GL_LINEAR)
		glEnable( GL_TEXTURE_2D )
		glShadeModel( GL_SMOOTH )
		glClearDepth( 1.0 )
		glDepthRange( 0.0, 1.0 )
		glEnable( GL_DEPTH_TEST )
		glDepthFunc( GL_LEQUAL )
		glHint( GL_PERSPECTIVE_CORRECTION_HINT , GL_NICEST )
		glEnable( GL_CULL_FACE )
		'glFrontFace( GL_CCW )
		glCullFace( GL_FRONT )
		
		glEnable( GL_NORMALIZE )
		glEnable( GL_COLOR_MATERIAL )
		
		glClearColor( 68/255.0 , 128/255.0 , 159/255.0 , 1.0 )
		
		ResizeGL( G_Width, G_Height )
		
		ReadAppArgs()
		
		Return True
	End Function
	
	Function EnableLightning()
		glEnable(GL_LIGHT0)
		glEnable(GL_LIGHTING)
		glEnable(GL_COLOR_MATERIAL)
	End Function
	
	Function DisableLightning()
		glDisable(GL_LIGHT0)
		glDisable(GL_LIGHTING)
		glDisable(GL_COLOR_MATERIAL)
	End Function
	
	Function DrawText( Txt:String, X:Int, Y:Int )
		GLDrawText( Txt, X, Y )
	End Function
	
	Function ResizeGL( Width:Float, Height:Float )
		glViewport( 0, 0, Width, Height)
		glMatrixMode( GL_PROJECTION )
		glLoadIdentity()
		gluPerspective( 45.0, Width/Height, 0.1, 100000.0 )
		glMatrixMode( GL_MODELVIEW )
		glLoadIdentity()
	End Function
	
	Function Cls()
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
	End Function
	
	Function Close()
		End
	End Function
	
	Function ReadAppArgs()
		If AppArgs.Length > 1
			If AppArgs[1] <> ""
				ModelDir = AppArgs[1]
			EndIf
		EndIf
	End Function
	
End Type
